/***************************************************************************
Sample ServiceDispatcher Class.
Copyright (C) 2000, Samuel Goldstein (samuelg@andthehorseyourodeinon.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://www.gnu.org/copyleft/gpl.html
***************************************************************************/
package com.andthehorseyourodeinon.ghear;

import java.io.*;
import java.net.*;
import java.util.*;
import com.andthehorseyourodeinon.utils.*;

/** This is a sample ServiceDispatcher.

@author <A HREF="mailto:samuelg@andthehorseyourodeinon.com">SjG</A>
@author http://www.andthehorseyourodeinon.com/
@version $Id: SampleServiceDispatcher.java,v 1.1 2000/05/16 22:41:13 samuelg Exp $
*/
public class SampleServiceDispatcher extends ServiceDispatcher {

	protected Properties serverOptions;
	protected Properties options;
	protected Hashtable services;
	protected String dispatcherName;
	protected Metrics mets;

	public SampleServiceDispatcher()
		{
		services = new Hashtable();
		dispatcherName = "Sample Dispatcher";
		}

	public void initDispatcher(Properties serverOptions, Metrics metrics)
		{
		this.serverOptions = serverOptions;
		this.mets = metrics;
		}
		
	public void initServices()
		{
		mets.start(" Initialization of ServiceDispatcher");
		addService("test", new SampleService(options, mets));
		mets.stop(" Initialization of ServiceDispatcher");
		}
		
	public Response getDispatchReport(ParameterVector pv)
		{
		return new Response(HttpURLConnection.HTTP_OK,
			"Your request: "+pv.toSingleLine()+".");
		}

}

