/***************************************************************************
Simple Mailer
Copyright (C) 2000, Samuel Goldstein (samuelg@andthehorseyourodeinon.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://www.gnu.org/copyleft/gpl.html
***************************************************************************/
package com.andthehorseyourodeinon.netgrep;

import java.io.*;
import java.lang.*;
import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

import com.andthehorseyourodeinon.utils.*;

/**  Cheesy, quick implementation of a Mailer class to support 
a Search Engine Monitor or Tracker Service.
@author <A HREF="mailto:samuelg@andthehorseyourodeinon.com">SjG</A>
@author http://www.andthehorseyourodeinon.com/
@version $Id: Mailer.java,v 1.2 2000/05/22 04:53:44 samuelg Exp $
*/
public class Mailer {

	/**
	@param options Properties general to all the search engine Monitors and Trackers.
	@param subject String containing message subject.
	@param message String containing message body.
	
	*/
	public Mailer(Properties opts, String subject, String message)
		{
		if (opts.getProperty("notifyemail","none").equals("none"))
			{
			Logger.debug(Logger.ERROR,"Don't know who to send notification.");
			}
		Logger.debug(Logger.BORE, "Sending notification email to "+opts.getProperty("notifyemail"));

		opts.put("user.name","NetGrep");
		
        	Session session = Session.getDefaultInstance(opts, null);

		try
			{
			Message msg = new MimeMessage(session);

			InternetAddress fromaddr = new 
					InternetAddress(opts.getProperty("from-address"));
			fromaddr.setPersonal("NetGrep");
			msg.setFrom(fromaddr);
			InternetAddress[] ret = 
				{new InternetAddress(opts.getProperty("reply-to","error"))};
			msg.setReplyTo(ret);
			InternetAddress[] address = 
				{new InternetAddress(opts.getProperty("notifyemail"))};
			msg.setRecipients(Message.RecipientType.TO, address);
			msg.setSubject(subject);
			msg.setText(message);

			Transport.send(msg);
			}
		catch (Exception e)
			{
			Logger.debug(Logger.ERROR, "Sending Error: " + e);
			}
	}

}
