/***************************************************************************
Search Engine Rceord Data Structure Class
Copyright (C) 2000, Samuel Goldstein (samuelg@andthehorseyourodeinon.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://www.gnu.org/copyleft/gpl.html
***************************************************************************/
package com.andthehorseyourodeinon.netgrep;

import java.util.*;

/**  Simple data-structure Search Engine Records.

@author <A HREF="mailto:samuelg@andthehorseyourodeinon.com">SjG</A>
@author http://www.andthehorseyourodeinon.com/
@version $Id: SearchEngineRecord.java,v 1.2 2000/05/22 04:53:44 samuelg Exp $
*/
public class SearchEngineRecord {

	public int position;
	public int previousPosition;
	public String theUrl;
	public Calendar created;
	public Calendar lastUpdated;

	/**
	@param theUrl the URL of the record
	@param index the initial position of that record
	*/
	public SearchEngineRecord(String theUrl, int index)
		{
		this.theUrl = theUrl;
		position = index;
		created = Calendar.getInstance();
		updateTimestamp();
		}

	public int getPosition()
		{
		return position;
		}
		
	public int getPreviousPosition()
		{
		return previousPosition;
		}
		
	public String getUrl()
		{
		return theUrl;
		}
		

	public Calendar created()
		{
		return created;
		}

	public Calendar lastUpdated()
		{
		return lastUpdated;
		}
		
	public void setPosition(int position)
		{
		previousPosition = this.position;
		this.position = position;
		updateTimestamp();
		}
		
	public void updateTimestamp()
		{
		lastUpdated = Calendar.getInstance();
		}
}
