
package com.andthehorseyourodeinon.utils;

import java.lang.*;
import java.util.Date;
import java.util.Hashtable;
import java.util.Enumeration;
import java.text.DateFormat;

import javax.servlet.http.*;
import magnet.GeneralUtils;

public class FormUtils {

	public static String selector(String theNames[], String theValues[], String selName)
		{
		String result = new String();
		
		for (int i=0;i<theNames.length;i++)
			{
			result = result + "<OPTION VALUE=\"" + theValues[i] + "\"";
			if ((selName != null) && (selName.equalsIgnoreCase(theValues[i])))
				{
				result = result + " SELECTED";
				}
			result = result + ">"+theNames[i]+"</OPTION>\n";
			}
		return result;
		}


	public static String codedSelector(String theNames[], int theValues[], int selected)
		{
		String result = new String();
		
		for (int i=0;i<theNames.length;i++)
			{
			result = result + "<OPTION VALUE=\"" + Integer.toString(theValues[i]) + "\"";
			if (selected == theValues[i])
				{
				result = result + " SELECTED";
				}
			result = result + ">"+theNames[i]+"</OPTION>\n";
			}
		return result;
		}


/*

Originally from the JavaScript (ouch!)

--------------------------------------------------------------------
textField.
--------------------------------------------------------------------
Creates an HTML text input tag that maintains its
contents from request to request.
--------------------------------------------------------------------

theName		- text field name
reqHandle	- request handle to this field (i.e., "request.theName")
(theSize)	- numbers of characters wide to paint the field
(maxLen)	- maximum number of characters that can be entered 
(action)	- JavaScript action function (i.e., `onChange="fn();"')
--------------------------------------------------------------------
v.1.0 1 Sept 98 SjG, samuelg@magnet.com
Copyright (C) 1998 Magnet Interactive
--------------------------------------------------------------------
*/
	public static String textField (String theName, String prevValue, int theSize,
		int maxLen, String theAction)
		{
		String result = new String();
	
		result = "<INPUT TYPE=\"TEXT\" NAME=\"" + theName + "\"";
		if (theSize > 0)
			{
			result = result + " SIZE=\"" + theSize + "\"";
			}
		if (maxLen > 0)
			{
			result = result + " MAXLENGTH=\"" + maxLen + "\"";
			}
		if (theAction != null)
			{
			result = result + " " + theAction;
			}
		if (prevValue == null)
			{
			result = result + ">\n";
			}
		else
			{
			result = result + "VALUE=\"" + GeneralUtils.unSqlSafeString(prevValue) + "\">";
			}
		return result;	
		}


	public static String passwordTextField (String theName, String prevValue, int theSize,
		int maxLen, String theAction)
		{
		String result = new String();
	
		result = "<INPUT TYPE=\"PASSWORD\" NAME=\"" + theName + "\"";
		if (theSize > 0)
			{
			result = result + " SIZE=\"" + theSize + "\"";
			}
		if (maxLen > 0)
			{
			result = result + " MAXLENGTH=\"" + maxLen + "\"";
			}
		if (theAction != null)
			{
			result = result + " " + theAction;
			}
		if (prevValue == null)
			{
			result = result + ">\n";
			}
		else
			{
			result = result + "VALUE=\"" + prevValue + "\">";
			}
		return result;	
		}


/* Originally from JavaScript. Yuck. Bletch!
--------------------------------------------------------------------
checkBox.
--------------------------------------------------------------------
Creates an HTML checkbox input tag that maintains its
contents from request to request.
--------------------------------------------------------------------

theName		- checkbox field name
reqHandle	- request handle to this field (i.e., "request.theName")
(value)		- checkbox value (if checked)
(tag)		- label to put after the checkbox
(defaultOn)	- defined if the default state should be checked
--------------------------------------------------------------------
v.1.0 1 Sept 98 SjG, samuelg@magnet.com
Copyright (C) 1998 Magnet Interactive
--------------------------------------------------------------------
*/
	public static String checkBox (String theName, String value, String label,
		boolean checked)
		{
		String result = "<INPUT TYPE=\"CHECKBOX\" NAME=\""+theName+"\"";
		
		if (value != null)
			{
			result = result +" VALUE=\""+value+"\"";
			}

		if (checked)
			{
			result = result + " CHECKED";
			}

		result = result +">";
		if (label != null)
			{
			result = result + "&nbsp;"+label;
			}
		return result;
	
		}


	public static String codedCheckArray (String basename, int values[], String labels[],
		int checked, String fontFace)
		{
		
		int i;
		String result = new String();
		
		for (i=0;i<labels.length;i++)
			{
			if (i % 2 == 0)
				{
				result = result + "<TR>";
				}
			result = result + "<TD ALIGN=\"LEFT\" VALIGN=\"TOP\">";
			if (fontFace != null)
				{
				result = result + "<FONT FACE=\""+fontFace+"\">";
				}
			
			result = result +"<INPUT TYPE=\"CHECKBOX\" NAME=\""+basename+i+
				"\" VALUE=\""+values[i]+"\"";

			if ((values[i] & checked) == values[i])
				{
				result = result + " CHECKED";
				}

			result = result +">";
			if (labels[i] != null)
				{
				result = result + "&nbsp;"+labels[i];
				}
			
			if (fontFace != null)
				{
				result = result + "</FONT>";
				}
			result = result + "</TD>\n";
			if (i % 2 == 1)
				{
				result = result + "</TR>";
				}
			}
		return result;
	
		}

/*
--------------------------------------------------------------------
textFieldWithDefault.
--------------------------------------------------------------------
Creates an HTML text input tag that maintains its
contents from request to request. This text field initially
has a default content, which gets replaced.
--------------------------------------------------------------------

theName		- text field name
reqHandle	- request handle to this field (i.e., "request.theName")
defVal		- default value for field
(theSize)	- numbers of characters wide to paint the field
(maxLen)	- maximum number of characters that can be entered 
--------------------------------------------------------------------
v.1.0 24 Sept 98 SjG, samuelg@magnet.com
Copyright (C) 1998 Magnet Interactive
--------------------------------------------------------------------

function textFieldWithDefault(theName, reqHandle, defVal) {

var theSize = 0;
var maxLen = 0;

if (textFieldWithDefault.arguments.length > 3)
	{
	theSize = textFieldWithDefault.arguments[3];	
	}
	
if (textFieldWithDefault.arguments.length > 4)
	{
	maxLen = textFieldWithDefault.arguments[4];	
	}

write('<INPUT TYPE="TEXT" NAME="'+theName+'"');

if (theSize > 0)
	{
	write(' SIZE="'+theSize+'"');
	}
if (maxLen > 0)
	{
	write(' MAXLENGTH="'+maxLen+'"');
	}
	
if (reqHandle == null)
	{
	write(' VALUE="'+defVal+'">');
	}
else
	{
	write(' VALUE="'+reqHandle+'">');
	}	
}

*/
/*
--------------------------------------------------------------------
checkBox.
--------------------------------------------------------------------
Creates an HTML checkbox input tag that maintains its
contents from request to request.
--------------------------------------------------------------------

theName		- checkbox field name
reqHandle	- request handle to this field (i.e., "request.theName")
(value)		- checkbox value (if checked)
(tag)		- label to put after the checkbox
(defaultOn)	- defined if the default state should be checked
--------------------------------------------------------------------
v.1.0 1 Sept 98 SjG, samuelg@magnet.com
Copyright (C) 1998 Magnet Interactive
--------------------------------------------------------------------

function checkBox (theName, reqHandle) {

var value = null;
var defaultOn = 0;
var tag = null;

if (checkBox.arguments.length > 2)
	{
	value = checkBox.arguments[2];	
	}

if (checkBox.arguments.length > 3)
	{
	tag = checkBox.arguments[3];	
	}
	
if (checkBox.arguments.length > 4)
	{
	defaultOn = 1;	
	}
	
write('<INPUT TYPE="CHECKBOX" NAME="'+theName+'"');
if (value != null)
	{
	write(' VALUE="'+value+'"');
	}

if ((reqHandle != null) || ((reqHandle == null) && defaultOn))
	{
	write(' CHECKED');
	}

write('>');

if (tag != null)
	{
	write(tag);
	}
	
}
*/
/*
--------------------------------------------------------------------
radio.
--------------------------------------------------------------------
Creates an HTML radio button input tag that maintains its
contents from request to request.
--------------------------------------------------------------------

theName		- radio button group name
reqHandle	- request handle to this field (i.e., "request.theName")
theValue	- radio button value (if checked)
(tag)		- label to put after the radio button
(func)		- JavaScript function to include
(defaultOn)	- defined if the default state should be checked
--------------------------------------------------------------------
v.1.0 1 Sept 98 SjG, samuelg@magnet.com
Copyright (C) 1998 Magnet Interactive
--------------------------------------------------------------------

function radio (theName, reqHandle, theValue) {

var defaultOn = 0;
var tag = null;
var func = null;

if (radio.arguments.length > 3)
	{
	tag = radio.arguments[3];	
	}

if (radio.arguments.length > 4)
	{
	func = radio.arguments[4];	
	}


if (radio.arguments.length > 5)
	{
	defaultOn = 1;	
	}
	
write('<INPUT TYPE="RADIO" NAME="'+theName+'" VALUE="'+theValue+'"');

if (func != null)
	{
	write(' '+func);
	}

if ((reqHandle == theValue) || ((reqHandle == null) && defaultOn))
	{
	write(' CHECKED');
	}

write('>');

if (tag != null)
	{
	write(tag);
	}
	
}
*/

/*
--------------------------------------------------------------------
showReq.
--------------------------------------------------------------------
Diagnostic utility function to display request attributes.
--------------------------------------------------------------------

theName		- request attribute name
reqHandle	- request handle to this attribute (i.e., "request.theName")
--------------------------------------------------------------------
v.1.0 17 Sept 98 SjG, samuelg@magnet.com
Copyright (C) 1998 Magnet Interactive
--------------------------------------------------------------------

function showReq(theName, reqHandle)
	{
	
	write('sR:OK');
	
	if (reqHandle != null)
		{
	write('sR:OK(!null)');
		write(theName+' = '+reqHandle);
		}
	else
		{
	write('sR:OK(null)');
		write(theName+' is not defined.');
		}
	write('<BR>');
	}
	
*/
/*
--------------------------------------------------------------------
writeCacheKiller
--------------------------------------------------------------------
Function to write a hidden field that can be used by the validation
routines to reject cached records.
--------------------------------------------------------------------
--------------------------------------------------------------------
v.1.0 14 Dec 98 SjG, samuelg@magnet.com
Copyright (C) 1998 Magnet Interactive
--------------------------------------------------------------------

function writeCacheKiller()
	{	
	write('<INPUT TYPE="HIDDEN" NAME="bestIfUsedByDate" VALUE="');
	write(getCacheDate());
	write('">\n');
	}
*/	
/*
--------------------------------------------------------------------
notCached
--------------------------------------------------------------------
Function returns true if the result set is fresh, false otherwise.
--------------------------------------------------------------------
reqHandle	- request handle to this attribute (i.e., "request.theName")
--------------------------------------------------------------------
v.1.0 14 Dec 98 SjG, samuelg@magnet.com
Copyright (C) 1998 Magnet Interactive
--------------------------------------------------------------------

function notCached(reqHandle)
	{
	if (reqHandle == null)
		{
		return false;
		}
		
	if (reqHandle.bestIfUsedByDate == null)
		{
		return false;
		}
	
	// more than a day old?

	if ((getCacheDate() - reqHandle.bestIfUsedByDate) > 86400000)
		{
		return false;
		}
		
	return true;
	}
	


*/	
/*
--------------------------------------------------------------------
getCacheDate
--------------------------------------------------------------------
Function that returns a coded date string for use by writeCacheKiller
and validation routines that use it
--------------------------------------------------------------------
--------------------------------------------------------------------
v.1.0 14 Dec 98 SjG, samuelg@magnet.com
Copyright (C) 1998 Magnet Interactive
--------------------------------------------------------------------

function getCacheDate()
	{
	theDate = new Date();
	return (Date.parse(theDate.toGMTString()));
	}
*/

}
