
package com.andthehorseyourodeinon.utils;

import java.lang.*;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;
import java.util.StringTokenizer;
import java.text.DateFormat;
import java.sql.Date;
import java.net.*;
import java.io.*;
import java.text.DecimalFormat;

public class GeneralUtils {

	public static boolean isAlphaSafeString(String theString)
		{
		if (theString == null)
			{
			return true;
			}
		int i=0;
		while (i<theString.length())
			{
			if (!Character.isLetterOrDigit(theString.charAt(i)))
				{
				char c = theString.charAt(i);
				if (!((c == '.') || (c == '-') || (c == '_') ||
					(c == ' ')))
						{
						return false;
						}
				}
			i++;
			}
		return true;
		}

	public static boolean isAlphaNumeric(String theString)
		{
		if (theString == null)
			{
			return true;
			}
		int i=0;
		while (i<theString.length())
			{
			if (!Character.isLetterOrDigit(theString.charAt(i)))
				{
				return false;
				}
			i++;
			}
		return true;
		}

	public static String replaceSubstring(String original, String find,
			String replace)
		{
		String retStr = new String(original);
		int startIndex = 0;
		int endpt;
	
		while (retStr.indexOf(find,startIndex) > -1)
			{
			endpt = retStr.indexOf(find,startIndex);
			retStr = retStr.substring(0,endpt) +
				replace +
				retStr.substring(endpt + find.length());
			startIndex = endpt + replace.length();
			}
        
		return retStr;
		}


	public static InputStream getHTMLStream(String urlString, Hashtable cookies)
		{
		String retStr = new String();

		URL theUrl;
		HttpURLConnection theConnection;
		String cookiestring = new String();
		boolean first = true;
		
		if (cookies != null)
			{
			Enumeration headItr = cookies.keys();
			while (headItr.hasMoreElements())
				{
				if (first)
					{
					first = false;
					}
				else
					{
					cookiestring = cookiestring + "; ";
					}
				String head = (String)headItr.nextElement();
				cookiestring = cookiestring + head+"="+
					(String)cookies.get(head);
				}
			}


		Hashtable headers = new Hashtable();

		// fake header info, to keep their logs interesting
		headers.put("Connection","Keep-Alive");
		headers.put("User-Agent","Mozilla/4.07 [en] (X11; I; Linux 2.0.36 i686)");
		headers.put("Accept","text/html, */*");
		headers.put("Accept-Encoding","gzip");
		headers.put("Accept-Language","en");
		headers.put("Accept-Charset","iso-8859-1,*,utf-8");
		if (cookiestring.length() > 0)
			{
			headers.put("Cookie",cookiestring);
			}
		
		try {
			theUrl = new URL(urlString);
			//System.err.println("Attempting to open: "+urlString);
			theConnection = (HttpURLConnection)theUrl.openConnection();

			Enumeration headItr = headers.keys();
			while (headItr.hasMoreElements())
				{
				String head = (String)headItr.nextElement();
				theConnection.setRequestProperty(head,(String)headers.get(head));
				}

			theConnection.setDefaultAllowUserInteraction(false);
			theConnection.setDoOutput(false);
			theConnection.setDoInput(true);
			theConnection.setUseCaches(false);
			theConnection.setRequestMethod("GET");
			theConnection.setFollowRedirects(true);
			return theConnection.getInputStream(); 
			}
		catch (Exception e)
			{
			e.printStackTrace();
			retStr = "getHTMLPage Exception! GET "+urlString+ " caused exception "+e.getMessage();
			}
		return null;
		}


	public static String getHTMLPage(String urlString, Hashtable cookies)
		{
		String retStr = new String();
	
		InputStream htmlIn = getHTMLStream(urlString, cookies);
		if (htmlIn == null)
			return null;

		try 
			{
			BufferedReader in = new BufferedReader(new InputStreamReader(htmlIn)); 
			String s;
			while ((s=in.readLine()) != null)
				{
				retStr = retStr + s+ "\n";
				}
			in.close();
			}
		catch (Exception e)
			{
			e.printStackTrace();
			retStr = "getHTMLPage Exception! GET "+urlString+ " caused exception "+e.getMessage();
			}
		return retStr;
		}


	public static String getHTMLPageRaw(String urlString, Vector cookieList, int depth)
		{
		String retStr = new String();

		URL theUrl;
		if (depth > 5)
			{
			return "Too many redirects...";
			}

		try {
			URL url = new URL(urlString);
			String theHost = url.getHost();
			int thePort = url.getPort();
			if (thePort == -1)
				{
				thePort = 80;
				}
			String thePath = url.getFile();

			InetAddress theHostIP = InetAddress.getByName(theHost);
			Socket socket = new Socket(theHostIP,thePort);
			PrintWriter out = new PrintWriter(new BufferedWriter(
				new OutputStreamWriter(socket.getOutputStream())),true);
			BufferedReader in = new BufferedReader (new InputStreamReader(
				socket.getInputStream()));
				
			out.print("GET "+thePath+" HTTP/1.0\r\n");
			out.print("User-Agent: Mozilla/4.07 [en] (X11; I; Linux 2.0.36 i686)\r\n");
			out.print("Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*\r\n");
			out.print("Accept-Encoding: gzip\r\n");
			out.print("Accept-Language: en\r\n");
			Enumeration cookies = cookieList.elements();
			while (cookies.hasMoreElements())
				{
				out.print("Cookie: "+cookies.nextElement()+"\r\n");
				}
			out.print("Accept-Charset: iso-8859-1,*,utf-8\r\n\r\n");
			out.flush();

			String s;
			while ((s=in.readLine()) != null)
				{
				retStr = retStr + s +"\n";
				}
			
			in.close();
			out.close();
			if (retStr.length() < 1)
				{
				// zero length results? This is an error!
				return null;
				}
			if (retStr.indexOf("HTTP/1.0 302") != -1)
				{
				// redirect! Handle it before returning.
				// is this specific to Reel.com?
				// whatever.
				Vector newCookies = new Vector();
				String dest="";
				StringTokenizer tokenizer=new StringTokenizer(retStr,"\n");
				while (tokenizer.hasMoreTokens())
					{
					String tok = tokenizer.nextToken();
					if (tok.indexOf(":") == -1)
						{
						// not a tagged line; ignore it.
						System.err.println("Ignoring it");
						continue;
						}
					if (tok.substring(0,tok.indexOf(":")).equalsIgnoreCase("Set-Cookie"))
						{
						newCookies.addElement(tok.substring(tok.indexOf(": ")+2));
						}
					else if (tok.substring(0,tok.indexOf(":")).equalsIgnoreCase("Location"))
						{
						dest = tok.substring(tok.indexOf(": ")+2);
						}
					}
				return getHTMLPageRaw(dest,newCookies,depth+1);
				}
			return retStr;
			}
		catch (Exception e)
			{
			e.printStackTrace();
			retStr = "httpPost Exception! POST "+urlString+ " caused exception "+e.getMessage();
			}
		return retStr;
		}

	public static InputStream getHTMLStreamRaw(String urlString, Vector cookieList)
		{
		return getHTMLStreamRaw(urlString, cookieList, null);
		}

	public static InputStream getHTMLStreamRaw(String urlString, Vector cookieList, String proxy)
		{
		String retStr = new String();
		try {
			URL url = new URL(proxy == null ? urlString : proxy);
			String theHost = url.getHost();
			int thePort = url.getPort();
			if (thePort == -1)
				{
				thePort = 80;
				}
			String thePath = proxy==null ? url.getFile() : urlString;

			InetAddress theHostIP = InetAddress.getByName(theHost);
			Socket socket = new Socket(theHostIP,thePort);
			PrintWriter out = new PrintWriter(new BufferedWriter(
				new OutputStreamWriter(socket.getOutputStream())),true);
			InputStream result = socket.getInputStream();
				
			out.print("GET "+thePath+" HTTP/1.0\r\n");
			out.print("User-Agent: Mozilla/4.07 [en] (X11; I; Linux 2.0.36 i686)\r\n");
			out.print("Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*\r\n");
			out.print("Accept-Encoding: gzip\r\n");
			out.print("Accept-Language: en\r\n");
			if (cookieList != null)
				{
				Enumeration cookies = cookieList.elements();
				while (cookies.hasMoreElements())
					{
					out.print("Cookie: "+cookies.nextElement()+"\r\n");
					}
				}
			out.print("Accept-Charset: iso-8859-1,*,utf-8\r\n\r\n");
			out.flush();
			return result;
			}
		catch (Exception e)
			{
			e.printStackTrace();
			retStr = "httpPost Exception! POST "+urlString+ " caused exception "+e.getMessage();
			}
		return null;
		}


	public static boolean downloadHTMLPageRaw(String urlString, Vector cookies, String fileName, String proxy)
		{
		FileOutputStream out;
		InputStream in;

		try 
			{
			out = new FileOutputStream(fileName);
			}
		catch (Exception e)
			{
			System.err.println("Unable to open file " + fileName +": " + e);
			return false;
			}

		in = getHTMLStreamRaw(urlString, cookies, proxy);
		if (in == null)
			return false;

		try
			{
			// strip off headers
			int count=0;
			while(true)
				{
				int ch = in.read();
				if (ch<0)
					break;
				if ((char)ch == '\n') 
					{
					if (count<=2)
						break;
					count = 0;
					}
				count++;
				}

			copyStream(in, out);
			in.close();
			out.close();
			}
		catch (IOException e)
			{
			System.err.println("Unable to download file " + urlString +" to file " + fileName +"\n" + e);
			return false;
			}


		return true;
		}


	public static void copyStream(InputStream in, OutputStream out) throws IOException
		{
		final int BUFFERSIZE = 4096*4;
		byte [] buffer = new byte[BUFFERSIZE];
		int numberRead;

		while ((numberRead = in.read(buffer)) >= 0)
			out.write(buffer, 0, numberRead);
		
		}




	public static String httpPost(String urlString, String urlEncodedData)
		{
		String retStr = new String();

		URL theUrl;
		HttpURLConnection theConnection;
		String cookiestring = new String();
		boolean first = true;
				
		try {
			//URL url = new URL(urlString);
			//test using echoserver...
			URL url = new URL("http://julia.la.magnet.com:10950/somepath/someotherpath/cgi.cgi");
			URLConnection con = url.openConnection();
			con.setDoInput(true);
			con.setDoOutput(true);
			con.setUseCaches(false);
			con.setRequestProperty("User-Agent","Mozilla/4.07 [en] (X11; I; Linux 2.0.36 i686)");
			con.setRequestProperty("Content-Type","application/x-www-form-urlencoded");
			con.setRequestProperty("Content-Length",Integer.toString(urlEncodedData.length()));
			con.setRequestProperty("Referer","http://mypersonal.la.magnet.com/DELETEME.html");
			
			con.setRequestProperty("Accept","image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*");
			con.setRequestProperty("Accept-Encoding","gzip");
			con.setRequestProperty("Accept-Language","en");
			con.setRequestProperty("Accept-Charset","iso-8859-1,*,utf-8");
			
			DataOutputStream out = new DataOutputStream(con.getOutputStream());
			out.writeBytes(urlEncodedData);
			out.flush();
			out.close();
			

			BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream())); 
			String s;
			while ((s=in.readLine()) != null)
				{
				retStr = retStr + s;
				}
			
			in.close();
			}
		catch (Exception e)
			{
			e.printStackTrace();
			retStr = "httpPost Exception! POST "+urlString+ " caused exception "+e.getMessage();
			}
		return retStr;
		}

	public static String httpPostRaw(String urlString, String urlEncodedData, String cookie)
		{
		String retStr = new String();

		URL theUrl;

		try {
			URL url = new URL(urlString);
			// but we'll cheat...
			String theHost = url.getHost();
			int thePort = url.getPort();
			if (thePort == -1)
				{
				thePort = 80;
				}
			String thePath = url.getFile();

			InetAddress theHostIP = InetAddress.getByName(theHost);
			Socket socket = new Socket(theHostIP,thePort);
			PrintWriter out = new PrintWriter(new BufferedWriter(
				new OutputStreamWriter(socket.getOutputStream())),true);
			BufferedReader in = new BufferedReader (new InputStreamReader(
				socket.getInputStream()));
				
			out.print("POST "+thePath+" HTTP/1.0\r\n");
			out.print("User-Agent: Mozilla/4.07 [en] (X11; I; Linux 2.0.36 i686)\r\n");
			out.print("Content-Type: application/x-www-form-urlencoded\r\n");
			out.print("Content-Length: " + Integer.toString(urlEncodedData.length()) +"\r\n");
			out.print("Referer: http://mypersonal.la.magnet.com/DELETEME.html\r\n");
			out.print("Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*\r\n");
			out.print("Accept-Encoding: gzip\r\n");
			out.print("Accept-Language: en\r\n");
			if (cookie != null)
				{
				out.print("Cookie: "+cookie+"\r\n");
				}
			out.print("Accept-Charset: iso-8859-1,*,utf-8\r\n\r\n");

			out.print(urlEncodedData+"\r\n");
			out.flush();

			String s;
			while ((s=in.readLine()) != null)
				{
				retStr = retStr + s +"\n";
				}
			
			in.close();
			out.close();
			if (retStr.length() < 1)
				{
				// zero length results? This is an error!
				return null;
				}
			if (retStr.indexOf("HTTP/1.0 302") != -1)
				{
				// redirect! Handle it before returning.
				// is this specific to Reel.com?
				// whatever.
				Vector newCookies = new Vector();
				String dest="";
				StringTokenizer tokenizer=new StringTokenizer(retStr,"\n");
				while (tokenizer.hasMoreTokens())
					{
					String tok = tokenizer.nextToken();
					if (tok.indexOf(":") == -1)
						{
						// not a tagged line; ignore it.
						continue;
						}
					if (tok.substring(0,tok.indexOf(":")).equalsIgnoreCase("Set-Cookie"))
						{
						newCookies.addElement(tok.substring(tok.indexOf(": ")+2));
						}
					else if (tok.substring(0,tok.indexOf(":")).equalsIgnoreCase("Location"))
						{
						dest = tok.substring(tok.indexOf(": ")+2);
						}
					}
				return getHTMLPageRaw(dest,newCookies,0);
				}
			return retStr;
			}
		catch (Exception e)
			{
			e.printStackTrace();
			retStr = "httpPost Exception! POST "+urlString+ " caused exception "+e.getMessage();
			}
		return retStr;
		}


		
	public static Vector betweenTags(String source, String startTag, String endTag)
		{
		Vector theRet = new Vector();
		int start, end, realEnd;
		boolean more;
		
		realEnd = source.lastIndexOf(endTag);
		
		if (realEnd == -1)
			{
			return theRet;
			}
			
		more = true;
		start = 0;
		end = 0;
		while (more)
			{
			start = source.indexOf(startTag, end);
			end = source.indexOf(endTag, start+startTag.length());
			if ((start < 0) || (end < 0) || (end == realEnd))
				{
				more = false;
				}
			else
				{
				theRet.addElement(source.substring(start+startTag.length(),end));
				}
			}
			
		return theRet;
		}

	// only snags the first tagged item...
	public static String singleBetweenTags(String source, String startTag, String endTag)
		{
		int start, end;
		start = source.indexOf(startTag);
		end = source.indexOf(endTag,start+startTag.length());
		
		if ((start == -1) || (end == -1))
			{
			return source;
			}
			
		return source.substring(start+startTag.length(),end);
		}
		
	public static String blowAwayTags(String source)
		{
		String retStr = new String();
		boolean inTag = false;

		int i=0;
		while (i<source.length())
			{
			if ((source.charAt(i) == '<') && (source.indexOf(">",i) != -1))
				{
				i = source.indexOf(">",i);
				}
			else
				{
				retStr = retStr + source.charAt(i);
				}
			i++;
			}

		return retStr;
		}


	// allow for some extra ellipsis in the maxLen!
	public static String truncateNicely(String source, int maxLen)
		{
		int chopPoint;

		if (source.length() < maxLen)
			{
			return source;
			}
			
		chopPoint = source.lastIndexOf(" ",maxLen);
		if (chopPoint < 0)
			{
			return source.substring(0,maxLen);
			}
		return source.substring(0,chopPoint)+"...";
		}

	public static String reasonableTimeUnits(long ms)
		{
		return displayTimeUnits(ms, false);
		}

	public static String displayTimeUnits(long ms, boolean abbreviated)
		{
		// where ms is milliseconds, of course.
		DecimalFormat fnFmt = new DecimalFormat("###0.###");
		DecimalFormat msFmt = new DecimalFormat("####.###");
		DecimalFormat noFmt = new DecimalFormat("#####");
		String response = "";
		long tmp;
		double tmp2;

		if (ms >= 86400000)
			{
			tmp = ms/86400000;
			response = response + noFmt.format(tmp);
			
			if (abbreviated)
				{
				response = response + "d ";
				}
			else
				{
			
				if (tmp > 1)
					{
					response = response + " days ";
					}
				else
					{
					response = response + " day ";
					}
				}
			ms = ms - (86400000*(int)tmp);
			}

		if (ms >= 3600000)
			{
			tmp = ms/3600000;
			response = response + noFmt.format(tmp);
			if (abbreviated)
				{
				response = response + "h ";
				}
			else
				{
				if (tmp > 1)
					{
					response = response + " hours ";
					}
				else
					{
					response = response + " hour ";
					}
				}
			
			ms = ms - (3600000*(int)tmp);
			}
			
		if (ms >= 60000)
			{
			tmp = ms/60000;
			response = response + noFmt.format(tmp);
			if (abbreviated)
				{
				response = response + "m ";
				}
			else
				{
				if (tmp > 1)
					{
					response = response + " minutes ";
					}
				else
					{
					response = response + " minute ";
					}
				}
			
			ms = ms - (60000*(int)tmp);
			}
			
		tmp2 = ms/1000.0;
		response = response + fnFmt.format(tmp2);
		if (abbreviated)
			{
			response = response + "s";
			}
		else
			{
			response = response + " seconds ";
			}

		return response;
		}

	
	public static String toMixedCase(String st)
		{
		StringBuffer result = new StringBuffer(st.length());
		boolean startChar = true;
		for (int i=0; i<st.length(); i++)
			{
			char ch = st.charAt(i);
			result.append( startChar ? Character.toUpperCase(ch) : Character.toLowerCase(ch));
			startChar = !Character.isLetterOrDigit(ch);
			}
		return result.toString();
		}

}
