package com.andthehorseyourodeinon.utils;

import com.andthehorseyourodeinon.utils.GeneralUtils;


public class PerfMetric {
	public long	totalTime;
	public long	shortestTime;
	public long	longestTime;
	public long	count;
	

	public PerfMetric()
		{
		totalTime = 0;
		shortestTime = 10000;
		longestTime = 0;
		count = 0;
		}

	public void update(long startTime, long endTime)
		{
		long thisTime = endTime - startTime;
		count++;
		totalTime = totalTime + thisTime;
		if (thisTime < shortestTime)
			{
			shortestTime = thisTime;
			}
		if (thisTime > longestTime)
			{
			longestTime = thisTime;
			}
		
		}
		
	public String report()
		{
		return  "Average Time: "+
			GeneralUtils.reasonableTimeUnits(totalTime/count)+
			"\nTotal Time: "+
			GeneralUtils.reasonableTimeUnits(totalTime) +
			"\nShortest Time: "+
			GeneralUtils.reasonableTimeUnits(shortestTime)+
			"\nLongest Time: "+
			GeneralUtils.reasonableTimeUnits(longestTime) +
			"\n-----\n";

			
		}
		
	public String avgTime()
		{
		return GeneralUtils.displayTimeUnits(totalTime/count, true);
		}
		
	public String totalTime()
		{
		return GeneralUtils.displayTimeUnits(totalTime, true);
		}
		
	public String shortestTime()
		{
		return GeneralUtils.displayTimeUnits(shortestTime, true);
		}

	public String longestTime()
		{
		return GeneralUtils.displayTimeUnits(longestTime, true);
		}
		
	public String totalSamples()
		{
		return ""+count;
		}


}
